/**********************************************************************

	FLASHDISK.C
	Z-World, 2002

	This program demonstrates a basic interface to read and write sectors
	on a standard PCMCIA flash disk.  See Tech Note TN222 for a more
	detailed description, including how to connect the PCMCIA device
	to the Rabbit 3000.
	
 **********************************************************************/

#use "atainterface.lib"

/**********************************************************************/

void setupRabbit()
{
	// enable the alternate I/O bus for read/writes with IOE prefix
	enableIObus();

	// initialize port E pins

	WrPortI(PEDR, &PEDRShadow, 0x01);	// set PE0 high
	WrPortI(PEDDR, &PEDDRShadow, 0x01);	// set PE0 as an output

	WrPortI(PEFR, &PEFRShadow, 0x01);	// enable I/O strobe on PE0
	WrPortI(IB0CR, &IB0CRShadow, 0xC8);	// PE0 is a chip select strobe
}

/**********************************************************************
	main
 **********************************************************************/

main()
{
	char	buf[512];
	int	i, j;
		

	setupRabbit();
	ataInit();

	
	
	for (i=0; i<10; i++) {
		sprintf(buf, "This is sector %d -- timestamp=%ld", i, MS_TIMER);
		ataWriteSector(i, buf);
	}
	
	for (i=0; i<10; i++) {
		ataReadSector(i, buf);
		printf("Read from sector %d:  '%s'\n", i, buf);
	}
}
