//////////////////////////////////////////////////////////////////////////////
//
//	makedummy.c
//	Z-World, 2002
//
//		Creates an empty file of a given size in bytes.  This program is
//		intended to be used with the flask disk support described in
//		Tech Note TN222.
//
////////////////////////////////////////////////////////////////////////////////

// this program was built with Borland C 5.02

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	DATASTRING	"ABCDEFGHIJKLMNOP"   // filler string
#define	DATASTRSIZE	16							// size of filler string
#define	DUMMYFILE	"DUMMY.TXT" 			// default file name

main(int argc, char *argv[])
{
	long	sz;
	char	c, buf[DATASTRSIZE];
   FILE	*fid;
	int	n;


   if (argc != 2) {
		fprintf(stderr, "Usage:  makedummy <size in bytes>\n");
      exit(1);
   }

   sz = atol(argv[1]);

   printf("You are about to create a file of size %ld bytes (%4.1f megabytes)\n",
   			sz, (float)sz/1048576.0);
   printf("called '%s'.  Are you sure? (y/n) ", DUMMYFILE, sz);
   c = getchar();
   if (c != 'y') {
		printf("Cancelled, exiting...\n");
      exit(1);
   }

   printf("Creating %s: ", DUMMYFILE);
   fid = fopen(DUMMYFILE, "w");
   if (!fid) {
		fprintf(stderr, "Cannot create %s\n", DUMMYFILE);
      exit(1);
   }

   // fill buffer that we will copy into file
   strncpy(buf, DATASTRING, DATASTRSIZE);

   n = 0;
	while (sz >= DATASTRSIZE) {
		fwrite(buf, DATASTRSIZE, 1, fid);
      sz -= DATASTRSIZE;
		n++;
      if (n == 256) {
			printf(".");
         n = 0;
      }
   }
   if (sz > 0)
		fwrite(buf, (int)sz, 1, fid);

   fclose(fid);
   printf(" done.\n");
   
	return(0);
}

